diff -c ../zip19i/zip.c ./zip.c
*** ../zip19i/zip.c	Tue Nov  3 21:07:56 1992
--- ./zip.c	Fri Sep 10 03:16:44 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 19,25 ****
  #ifdef VMS
  #  include "VMSmunch.h"
  #endif
! #if defined(MSDOS) && !defined(__GO32__)
  #  include <process.h>
  #endif
  #include <signal.h>
--- 18,24 ----
  #ifdef VMS
  #  include "VMSmunch.h"
  #endif
! #if (defined(MSDOS) && !defined(__GO32__)) || defined(__human68k__)
  #  include <process.h>
  #endif
  #include <signal.h>
***************
*** 39,54 ****
  local int action = ADD; /* one of ADD, UPDATE, FRESHEN, or DELETE */
  local int comadd = 0;   /* 1=add comments for new files */
  local int zipedit = 0;  /* 1=edit zip comment and all file comments */
- local int dispose = 0;  /* 1=remove files after put in zip file */
  local int latest = 0;   /* 1=set zip file time to time of latest file */
  local ulg before = 0;   /* 0=ignore, else exclude files before this time */
  local int test = 0;     /* 1=test zip file with unzip -t */
  
  /* Temporary zip file name and file pointer */
  local char *tempzip;
  local FILE *tempzf;
  
- 
  /* Local functions */
  
  local void freeup  OF((void));
--- 38,52 ----
  local int action = ADD; /* one of ADD, UPDATE, FRESHEN, or DELETE */
  local int comadd = 0;   /* 1=add comments for new files */
  local int zipedit = 0;  /* 1=edit zip comment and all file comments */
  local int latest = 0;   /* 1=set zip file time to time of latest file */
  local ulg before = 0;   /* 0=ignore, else exclude files before this time */
  local int test = 0;     /* 1=test zip file with unzip -t */
+ local int tempdir = 0;  /* 1=use temp directory (-b) */
  
  /* Temporary zip file name and file pointer */
  local char *tempzip;
  local FILE *tempzf;
  
  /* Local functions */
  
  local void freeup  OF((void));
***************
*** 58,64 ****
  local void help    OF((void));
  local void zipstdout OF((void));
  local void check_zipfile OF((char *zipname));
!       void  main     OF((int, char **));
  local int count_args OF((char *s));
  local void envargs   OF((int *Pargc, char ***Pargv, char *envstr));
  
--- 56,63 ----
  local void help    OF((void));
  local void zipstdout OF((void));
  local void check_zipfile OF((char *zipname));
! local void get_filters OF((int argc, char **argv));
!       int  main     OF((int, char **));
  local int count_args OF((char *s));
  local void envargs   OF((int *Pargc, char ***Pargv, char *envstr));
  
***************
*** 101,120 ****
    struct zlist far *z;  /* pointer into zfile list */
  
    /* If latest, set time to zip file to latest file in zip file */
!   if (latest && strcmp(zipfile, "-"))
    {
      diag("changing time of zip file to time of latest file in it");
      /* find latest time in zip file */
      if (zfiles == NULL)
         warn("zip file is empty, can't make it as old as latest entry", "");
      else {
!       t = zfiles->tim;
!       for (z = zfiles->nxt; z != NULL; z = z->nxt)
          /* Ignore directories in time comparisons */
          if (t < z->tim && z->zname[z->nam-1] != '/')
            t = z->tim;
        /* set modified time of zip file to that time */
!       stamp(zipfile, t);
      }
    }
    if (tempath != NULL)
--- 100,124 ----
    struct zlist far *z;  /* pointer into zfile list */
  
    /* If latest, set time to zip file to latest file in zip file */
!   if (latest && zipfile && strcmp(zipfile, "-"))
    {
      diag("changing time of zip file to time of latest file in it");
      /* find latest time in zip file */
      if (zfiles == NULL)
         warn("zip file is empty, can't make it as old as latest entry", "");
      else {
!       t = 0;
!       for (z = zfiles; z != NULL; z = z->nxt)
          /* Ignore directories in time comparisons */
          if (t < z->tim && z->zname[z->nam-1] != '/')
            t = z->tim;
        /* set modified time of zip file to that time */
!       if (t != 0)
!         stamp(zipfile, t);
!       else
!         warn(
!          "zip file has only directories, can't make it as old as latest entry",
!          "");
      }
    }
    if (tempath != NULL)
***************
*** 156,164 ****
    static int error_level;
    if (error_level++ > 0) exit(0);  /* avoid recursive err() */
  
!   if (PERR(c))
!     perror("zip error");
!   fprintf(stderr, "zip error: %s (%s)\n", errors[c-1], h);
    if (tempzip != NULL)
    {
      if (tempzip != zipfile) {
--- 160,171 ----
    static int error_level;
    if (error_level++ > 0) exit(0);  /* avoid recursive err() */
  
!   if (h != NULL) {
!     if (PERR(c))
!       perror("zip error");
!     fflush(mesg);
!     fprintf(stderr, "\nzip error: %s (%s)\n", errors[c-1], h);
!   }
    if (tempzip != NULL)
    {
      if (tempzip != zipfile) {
***************
*** 215,221 ****
  /* Upon getting a user interrupt, turn echo back on for tty and abort
     cleanly using err(). */
  {
! #ifndef MSDOS
    echon();
    putc('\n', stderr);
  #endif /* !MSDOS */
--- 222,228 ----
  /* Upon getting a user interrupt, turn echo back on for tty and abort
     cleanly using err(). */
  {
! #if !defined(MSDOS) && !defined(__human68k__)
    echon();
    putc('\n', stderr);
  #endif /* !MSDOS */
***************
*** 228,234 ****
  char *a, *b;            /* message strings juxtaposed in output */
  /* Print a warning message to stderr and return. */
  {
!   fprintf(stderr, "zip warning: %s%s\n", a, b);
  }
  
  
--- 235,241 ----
  char *a, *b;            /* message strings juxtaposed in output */
  /* Print a warning message to stderr and return. */
  {
!   if (noisy) fprintf(stderr, "zip warning: %s%s\n", a, b);
  }
  
  
***************
*** 255,287 ****
    static char *text[] = {
  "",
  "Zip %s (%s). Usage:",
! "zip [-options] [-b path] [-t mmddyy] [-n suffixes] [zipfile list] [-x list]",
  "  The default action is to add or replace zipfile entries from list, which",
  "  can include the special name - to compress standard input.",
  "  If zipfile and list are omitted, zip compresses stdin to stdout.",
  "  -f   freshen: only changed files  -u   update: only changed or new files",
  "  -d   delete entries in zipfile    -m   move into zipfile (delete files)",
  "  -k   simulate PKZIP made zipfile  -g   allow growing existing zipfile",
- #ifdef VMS
- "  -h   show this help              \"-L\"  show software license",
- #else
- "  -h   show this help               -L   show software license",
- #endif
  "  -r   recurse into directories     -j   junk (don't record) directory names",
  "  -0   store only                   -l   convert LF to CR LF (-ll CR LF to LF)",
  "  -1   compress faster              -9   compress better",
! "  -q   quiet operation              -n   don't compress these suffixes",
  "  -c   add one-line comments        -z   add zipfile comment",
! "  -b   use \"path\" for temp files    -t   only do files after \"mmddyy\"",
  "  -@   read names from stdin        -o   make zipfile as old as latest entry",
! #ifdef CRYPT
! "  -e   encrypt  (-ee verify key)    -T   test zipfile integrity",
! #else
! "  -T   test zipfile integrity",
! #endif
  #ifdef VMS
  "  -w   append the VMS version number to the name stored in the zip file",
  " \"-V\"  save VMS file attributes",
  #endif /* VMS */
  #ifdef OS2
  "  -E   use the .LONGNAME Extended attribute (if found) as filename",
--- 262,290 ----
    static char *text[] = {
  "",
  "Zip %s (%s). Usage:",
! "zip [-options] [-b path] [-t mmddyy] [-n suffixes] [zipfile list] [-xi list]",
  "  The default action is to add or replace zipfile entries from list, which",
  "  can include the special name - to compress standard input.",
  "  If zipfile and list are omitted, zip compresses stdin to stdout.",
  "  -f   freshen: only changed files  -u   update: only changed or new files",
  "  -d   delete entries in zipfile    -m   move into zipfile (delete files)",
  "  -k   simulate PKZIP made zipfile  -g   allow growing existing zipfile",
  "  -r   recurse into directories     -j   junk (don't record) directory names",
  "  -0   store only                   -l   convert LF to CR LF (-ll CR LF to LF)",
  "  -1   compress faster              -9   compress better",
! "  -q   quiet operation              -v   verbose operation",
  "  -c   add one-line comments        -z   add zipfile comment",
! "  -b   use \"path\" for temp file     -t   only do files after \"mmddyy\"",
  "  -@   read names from stdin        -o   make zipfile as old as latest entry",
! "  -x   exclude the following names  -i   include only the following names",
  #ifdef VMS
+ " \"-F\"  fix zipfile(-FF try harder) \"-D\"  do not add directory entries",
+ " \"-T\"  test zipfile integrity      \"-L\"  show software license",
  "  -w   append the VMS version number to the name stored in the zip file",
  " \"-V\"  save VMS file attributes",
+ #else
+ "  -F   fix zipfile (-FF try harder) -D   do not add directory entries",
+ "  -T   test zipfile integrity       -L   show software license",
  #endif /* VMS */
  #ifdef OS2
  "  -E   use the .LONGNAME Extended attribute (if found) as filename",
***************
*** 289,295 ****
  #ifdef S_IFLNK
  "  -y   store symbolic links as the link instead of the referenced file",
  #endif /* !S_IFLNK */
! "  -x   exclude the names that follow from those operated on"
    };
  
    for (i = 0; i < sizeof(copyright)/sizeof(char *); i++)
--- 292,305 ----
  #ifdef S_IFLNK
  "  -y   store symbolic links as the link instead of the referenced file",
  #endif /* !S_IFLNK */
! #if defined(MSDOS) || defined(OS2)
! "  -$   include volume label         -S   include system and hidden files",
! #endif
! #ifdef CRYPT
! "  -e   encrypt  (-ee verify key)    -n   don't compress these suffixes"
! #else
! "  -h   show this help               -n   don't compress these suffixes"
! #endif
    };
  
    for (i = 0; i < sizeof(copyright)/sizeof(char *); i++)
***************
*** 305,312 ****
  }
  
  
! /* Do command line expansion for MSDOS and VMS */
! #if defined(MSVMS) && !defined(__GO32__)
  #  define PROCNAME(n) (action==ADD||action==UPDATE?wild(n):procname(n))
  #else /* !MSVMS */
  #  define PROCNAME(n) procname(n)
--- 315,322 ----
  }
  
  
! /* Do command line expansion for MSDOS, VMS, ATARI, and AMIGA but not OS/2 */
! #if defined(MSVMS) || defined(AMIGA)
  #  define PROCNAME(n) (action==ADD||action==UPDATE?wild(n):procname(n))
  #else /* !MSVMS */
  #  define PROCNAME(n) procname(n)
***************
*** 331,339 ****
    char *zipname;
    /* Invoke unzip -t on the given zip file */
  {
! #if defined(MSDOS) && !defined(__GO32__)
     if (spawnlp(P_WAIT, "unzip", "unzip", verbose ? "-t" : "-tqq",
! 	       zipname, NULL)) {
  #else
     char cmd[128];
     strcpy(cmd, "unzip -t ");
--- 341,349 ----
    char *zipname;
    /* Invoke unzip -t on the given zip file */
  {
! #if (defined(MSDOS) && !defined(__GO32__)) || defined(__human68k__)
     if (spawnlp(P_WAIT, "unzip", "unzip", verbose ? "-t" : "-tqq",
!                zipname, NULL)) {
  #else
     char cmd[128];
     strcpy(cmd, "unzip -t ");
***************
*** 346,359 ****
  # endif
  #endif
       fprintf(mesg, "test of %s FAILED\n", zipfile);
!      err(ZE_FORM, "original files unmodified");
     }
     if (noisy)
       fprintf(mesg, "test of %s OK\n", zipfile);
  }
  
  
! void main(argc, argv)
  int argc;               /* number of tokens in command line */
  char **argv;            /* command line tokens */
  /* Add, update, freshen, or delete zip entries in a zip file.  See the
--- 356,403 ----
  # endif
  #endif
       fprintf(mesg, "test of %s FAILED\n", zipfile);
!      err(ZE_TEST, "original files unmodified");
     }
     if (noisy)
       fprintf(mesg, "test of %s OK\n", zipfile);
  }
  
+ local void get_filters(argc, argv)
+   int argc;               /* number of tokens in command line */
+   char **argv;            /* command line tokens */
+ /* Counts number of -i or -x patterns, sets patterns and pcount */
+ {
+   int i;
+   int flag = 0;
+ 
+   pcount = 0;
+   for (i = 1; i < argc; i++) {
+     if (argv[i][0] == '-') {
+       if (strrchr(argv[i], 'i') != NULL) {
+         flag = 'i';
+       } else if (strrchr(argv[i], 'x') != NULL) {
+         flag = 'x';
+       } else {
+         flag = 0;
+       }
+     } else if (flag) {
+       if (patterns != NULL) {
+         patterns[pcount].zname = ex2in(argv[i], 0, (int *)NULL);
+         patterns[pcount].select = flag;
+         if (flag == 'i') icount++;
+       }
+       pcount++;
+     }
+   }
+   if (pcount == 0 || patterns != NULL) return;
+   patterns = (struct plist*) malloc(pcount * sizeof(struct plist));
+   if (patterns == NULL)
+     err(ZE_MEM, "was creating pattern list");
+   get_filters(argc, argv);
+ }
+ 
  
! int main(argc, argv)
  int argc;               /* number of tokens in command line */
  char **argv;            /* command line tokens */
  /* Add, update, freshen, or delete zip entries in a zip file.  See the
***************
*** 372,385 ****
--- 416,440 ----
    char *p;              /* steps through option arguments */
    char *pp;             /* temporary pointer */
    int r;                /* temporary variable */
+   int s;                /* flag to read names from stdin */
    ulg t;                /* file time, length of central directory */
    struct zlist far *v;  /* temporary variable */
    struct zlist far * far *w;    /* pointer to last link in zfiles list */
    FILE *x, *y;          /* input and output zip files */
    struct zlist far *z;  /* steps through zfiles linked list */
    char *zipbuf;         /* stdio buffer for the zip file */
+   FILE *comment_stream; /* set to stderr if anything is read from stdin */
+ 
+ #if defined(__IBMC__) && defined(__DEBUG_ALLOC__)
+   {
+     extern void DebugMalloc(void);
+     atexit(DebugMalloc);
+   }
+ #endif
  
    mesg = (FILE *) stdout; /* cannot be made at link time for VMS */
+   comment_stream = (FILE *)stdin;
+ 
    init_upper();           /* build case map table */
  
  #ifdef MACOS
***************
*** 399,406 ****
--- 454,467 ----
    tempzf = NULL;
    d = 0;                        /* disallow adding to a zip file */
    signal(SIGINT, handler);
+ #ifdef SIGTERM                  /* AMIGADOS and others have no SIGTERM */
    signal(SIGTERM, handler);
+ #endif
    k = 0;                        /* Next non-option argument type */
+   s = 0;                        /* set by -@ if -@ is early */
+ 
+   get_filters(argc, argv);      /* scan first the -x and -i patterns */
+ 
    for (i = 1; i < argc; i++)
    {
      if (argv[i][0] == '-')
***************
*** 415,420 ****
--- 476,482 ----
                          /* Set the compression efficacy */
                level = *p - '0';  break;
              case 'b':   /* Specify path for temporary file */
+               tempdir = 1;
                if (k != 0)
                  err(ZE_PARMS, "use -b before zip file name");
                else
***************
*** 427,432 ****
--- 489,496 ----
                  err(ZE_PARMS, "specify just one action");
                action = DELETE;
                break;
+             case 'D':   /* Do not add directory entries */
+               dirnames = 0; break;
              case 'e':   /* Encrypt */
  #ifndef CRYPT
                err(ZE_PARMS, "encryption not supported");
***************
*** 446,451 ****
--- 510,517 ----
                }
  #endif /* ?CRYPT */
                break;
+             case 'F':   /* fix the zip file */
+               fix++; latest = 1; break;
              case 'f':   /* Freshen zip file--overwrite only */
                if (action != ADD)
                  err(ZE_PARMS, "specify just one action");
***************
*** 478,483 ****
--- 544,552 ----
                noisy = 0;  break;
              case 'r':   /* Recurse into subdirectories */
                recurse = 1;  break;
+             case 'S':
+               hidden_files = 1;
+               break;
              case 't':   /* Exclude files earlier than specified date */
                if (before)
                  err(ZE_PARMS, "can only have one -t");
***************
*** 493,516 ****
                verbose++;
                break;
  #ifdef VMS
-             case 'w':   /* Append the VMS version number */
-               vmsver = 1;  break;
              case 'V':   /* Store in VMS format */
                vms_native = 1; break;
  #endif /* VMS */
              case 'x':   /* Exclude following files */
                if (k != 4 &&
                    (k != 3 || (action != UPDATE && action != FRESHEN)))
!                 err(ZE_PARMS, "nothing to exclude (-x) from");
!               if (k == 3)       /* must be -u or -f */
!                 for (z = zfiles; z != NULL; z = z->nxt)
!                   z->mark = 1;  /* mark all of them */
                k = 5;
-               if ((r = exclude()) != ZE_OK)
-                 if (r == ZE_PARMS)
-                   err(r, "cannot repeat names in zip file");
-                 else
-                   err(r, "was processing list of files");
                break;
  #ifdef S_IFLNK
              case 'y':   /* Store symbolic links as such */
--- 562,578 ----
                verbose++;
                break;
  #ifdef VMS
              case 'V':   /* Store in VMS format */
                vms_native = 1; break;
+             case 'w':   /* Append the VMS version number */
+               vmsver = 1;  break;
  #endif /* VMS */
+             case 'i':   /* Include only the following files */
              case 'x':   /* Exclude following files */
                if (k != 4 &&
                    (k != 3 || (action != UPDATE && action != FRESHEN)))
!                 err(ZE_PARMS, "nothing to select from");
                k = 5;
                break;
  #ifdef S_IFLNK
              case 'y':   /* Store symbolic links as such */
***************
*** 518,532 ****
  #endif /* S_IFLNK */
              case 'z':   /* Edit zip file comment */
                zipedit = 1;  break;
              case '@':   /* read file names from stdin */
!               while ((pp = getnam(errbuf)) != NULL)
!               {
!                 if ((r = PROCNAME(pp)) != ZE_OK)
!                   if (r == ZE_MISS)
!                     warn("name not matched: ", pp);
!                   else
!                     err(r, pp);
!               }
                break;
  #ifdef OS2
              case 'E':
--- 580,604 ----
  #endif /* S_IFLNK */
              case 'z':   /* Edit zip file comment */
                zipedit = 1;  break;
+ #if defined(MSDOS) || defined(OS2)
+             case '$':   /* Include volume label */
+               volume_label = 1; break;
+ #endif
              case '@':   /* read file names from stdin */
!               comment_stream = NULL;
!               if (k < 3)        /* zip file not read yet */
!                 s = 1;          /* defer -@ until after zipfile read */
!               else if (strcmp(zipfile, "-") == 0)
!                 err(ZE_PARMS, "can't use - and -@ together");
!               else              /* zip file read--do it now */
!                 while ((pp = getnam(errbuf)) != NULL)
!                 {
!                   if ((r = PROCNAME(pp)) != ZE_OK)
!                     if (r == ZE_MISS)
!                       warn("name not matched: ", pp);
!                     else
!                       err(r, pp);
!                 }
                break;
  #ifdef OS2
              case 'E':
***************
*** 546,551 ****
--- 618,625 ----
          case 0:
            zipstdout();
            k = 3;
+           if (s)
+             err(ZE_PARMS, "can't use - and -@ together");
            break;
          case 1:
            err(ZE_PARMS, "invalid path");
***************
*** 553,559 ****
          case 2:
            err(ZE_PARMS, "invalid time");
            break;
!         case 3:  case 4:  case 5:
            if ((r = PROCNAME(argv[i])) != ZE_OK)
              if (r == ZE_MISS)
                warn("name not matched: ", argv[i]);
--- 627,634 ----
          case 2:
            err(ZE_PARMS, "invalid time");
            break;
!         case 3:  case 4:
!           comment_stream = NULL;
            if ((r = PROCNAME(argv[i])) != ZE_OK)
              if (r == ZE_MISS)
                warn("name not matched: ", argv[i]);
***************
*** 566,573 ****
      {
        if (special == NULL)
          special = argv[i];
!       else
!         switch (k)
        {
          case 0:
            if ((zipfile = ziptyp(argv[i])) == NULL)
--- 641,649 ----
      {
        if (special == NULL)
          special = argv[i];
!       else if (k == 5)
!         break; /* -i and -x arguments already scanned */
!       else switch (k)
        {
          case 0:
            if ((zipfile = ziptyp(argv[i])) == NULL)
***************
*** 575,580 ****
--- 651,668 ----
            if ((r = readzipfile()) != ZE_OK)
              err(r, zipfile);
            k = 3;
+           if (s)
+           {
+             while ((pp = getnam(errbuf)) != NULL)
+             {
+               if ((r = PROCNAME(pp)) != ZE_OK)
+                 if (r == ZE_MISS)
+                   warn("name not matched: ", pp);
+                 else
+                   err(r, pp);
+             }
+             s = 0;
+           }
            break;
          case 1:
            if ((tempath = malloc(strlen(argv[i]) + 1)) == NULL)
***************
*** 593,599 ****
            k = 0;
            break;
          }
!         case 3:  case 4:  case 5:
            if ((r = PROCNAME(argv[i])) != ZE_OK)
              if (r == ZE_MISS)
                warn("name not matched: ", argv[i]);
--- 681,687 ----
            k = 0;
            break;
          }
!         case 3:  case 4:
            if ((r = PROCNAME(argv[i])) != ZE_OK)
              if (r == ZE_MISS)
                warn("name not matched: ", argv[i]);
***************
*** 606,630 ****
    }
    if (k < 3) {               /* zip used as filter */
      zipstdout();
      if ((r = procname("-")) != ZE_OK)
        if (r == ZE_MISS)
          warn("name not matched: ", "-");
        else
          err(r, "-");
      k = 4;
    }
  
!   if (k != 5)                   /* Clean up selections */
!   {
!     if (k == 3 && (action == UPDATE || action == FRESHEN))
!       for (z = zfiles; z != NULL; z = z->nxt)
!         z->mark = 1;                    /* if -u or -f with no args, do all */
!     if ((r = exclude()) != ZE_OK)       /* remove duplicates in found list */
!       if (r == ZE_PARMS)
!         err(r, "cannot repeat names in zip file");
!       else
!         err(r, "was processing list of files");
    }
    if (zcount)
      free((voidp *)zsort);
  
--- 694,723 ----
    }
    if (k < 3) {               /* zip used as filter */
      zipstdout();
+     comment_stream = NULL;
      if ((r = procname("-")) != ZE_OK)
        if (r == ZE_MISS)
          warn("name not matched: ", "-");
        else
          err(r, "-");
      k = 4;
+     if (s)
+       err(ZE_PARMS, "can't use - and -@ together");
    }
  
!   /* Clean up selections */
!   if (k == 3 && (action == UPDATE || action == FRESHEN)) {
!     for (z = zfiles; z != NULL; z = z->nxt) {
!       /* if -u or -f with no args, do all */
!       z->mark = pcount ? filter(z->zname) : 1;
!     }
    }
+   if ((r = check_dup()) != ZE_OK)     /* remove duplicates in found list */
+     if (r == ZE_PARMS)
+       err(r, "cannot repeat names in zip file");
+     else
+       err(r, "was processing list of files");
+ 
    if (zcount)
      free((voidp *)zsort);
  
***************
*** 638,646 ****
        key != NULL || comadd || zipedit))
      err(ZE_PARMS, "invalid option(s) used with -d");
    if (linkput && dosify)
!     err(ZE_PARMS, "can't use -y with -k");
!   if ((action != ADD || d || test) && !strcmp(zipfile, "-"))
!     err(ZE_PARMS, "can't use -d,-f,-u, -g or -T\n  on standard output");
  #ifdef VMS
    if (vms_native && translate_eol)
      err(ZE_PARMS, "can't use -V with -l");
--- 731,745 ----
        key != NULL || comadd || zipedit))
      err(ZE_PARMS, "invalid option(s) used with -d");
    if (linkput && dosify)
!     {
!       warn("can't use -y with -k, -y ignored", "");
!       linkput = 0;
!     }
!   if (test && !strcmp(zipfile, "-")) {
!     warn("can't use -T on stdout, -T ignored", "");
!   }
!   if ((action != ADD || d) && !strcmp(zipfile, "-"))
!     err(ZE_PARMS, "can't use -d,-f,-u or -g on stdout\n");
  #ifdef VMS
    if (vms_native && translate_eol)
      err(ZE_PARMS, "can't use -V with -l");
***************
*** 650,666 ****
  
  
    /* If -b not specified, make temporary path the same as the zip file */
! #ifdef MSDOS
    if (tempath == NULL && ((p = strrchr(zipfile, '/')) != NULL ||
                            (p = strrchr(zipfile, '\\')) != NULL ||
                            (p = strrchr(zipfile, ':')) != NULL))
    {
      if (*p == ':')
        p++;
! #else /* !MSDOS */
    if (tempath == NULL && (p = strrchr(zipfile, '/')) != NULL)
    {
! #endif /* ?MSDOS */
      if ((tempath = malloc((int)(p - zipfile) + 1)) == NULL)
        err(ZE_MEM, "was processing arguments");
      r = *p;  *p = 0;
--- 749,767 ----
  
  
    /* If -b not specified, make temporary path the same as the zip file */
! #if defined(MSDOS) || defined(__human68k__) || defined(AMIGA)
    if (tempath == NULL && ((p = strrchr(zipfile, '/')) != NULL ||
+ #  ifdef MSDOS
                            (p = strrchr(zipfile, '\\')) != NULL ||
+ #  endif
                            (p = strrchr(zipfile, ':')) != NULL))
    {
      if (*p == ':')
        p++;
! #else
    if (tempath == NULL && (p = strrchr(zipfile, '/')) != NULL)
    {
! #endif
      if ((tempath = malloc((int)(p - zipfile) + 1)) == NULL)
        err(ZE_MEM, "was processing arguments");
      r = *p;  *p = 0;
***************
*** 674,680 ****
    diag("stating marked entries");
    k = 0;                        /* Initialize marked count */
    for (z = zfiles; z != NULL; z = z->nxt)
!     if (z->mark)
        if (action != DELETE &&
                  ((t = filetime(z->name, (ulg *)NULL, (long *)NULL)) == 0 ||
                   t < before ||
--- 775,781 ----
    diag("stating marked entries");
    k = 0;                        /* Initialize marked count */
    for (z = zfiles; z != NULL; z = z->nxt)
!     if (z->mark) {
        if (action != DELETE &&
                  ((t = filetime(z->name, (ulg *)NULL, (long *)NULL)) == 0 ||
                   t < before ||
***************
*** 682,694 ****
        {
          z->mark = 0;
          z->trash = t && t >= before;    /* delete if -um or -fm */
!         if (verbose)
            fprintf(mesg, "zip diagnostic: %s %s\n", z->name,
                   z->trash ? "up to date" : "missing or early");
        }
        else
          k++;
! 
  
    /* Remove entries from found list that do not exist or are too old */
    diag("stating new entries");
--- 783,800 ----
        {
          z->mark = 0;
          z->trash = t && t >= before;    /* delete if -um or -fm */
!         if (verbose) {
            fprintf(mesg, "zip diagnostic: %s %s\n", z->name,
                   z->trash ? "up to date" : "missing or early");
+         }
        }
        else
          k++;
! #if 0
!       fprintf(mesg, "t %ld, z->tim %ld, t-tim %ld\n", t, z->tim,
!               t-z->tim); /* ??? */
! #endif
!     }
  
    /* Remove entries from found list that do not exist or are too old */
    diag("stating new entries");
***************
*** 716,737 ****
    d = (d && k == 0 && (zipbeg || zfiles != NULL)); /* d true if appending */
  
  
!   /* Before we get carried away, make sure zip file is writeable */
    if (strcmp(zipfile, "-"))
    {
!     x = zfiles == NULL && zipbeg == 0 ? fopen(zipfile, FOPW) : 
!                                         fopen(zipfile, FOPM);
!     /* Note: FOPW and FOPM expand to several parameters for VMS */
!     if (x == NULL)
!       err(ZE_CREAT, zipfile);
!     fclose(x);
!     a = getfileattr(zipfile);
!     if (zfiles == NULL && zipbeg == 0)
!       destroy(zipfile);
    }
    else
      a = 0;
  
  
    /* Open zip file and temporary output file */
    diag("opening zip file and creating temporary zip file");
--- 822,853 ----
    d = (d && k == 0 && (zipbeg || zfiles != NULL)); /* d true if appending */
  
  
!   /* Before we get carried away, make sure zip file is writeable. This
!    * has the undesired side effect of leaving one empty junk file on a WORM,
!    * so when the zipfile does not exist already and when -b is specified,
!    * the writability check is made in replace().
!    */
    if (strcmp(zipfile, "-"))
    {
!     if (tempdir && zfiles == NULL && zipbeg == 0) {
!       a = 0;
!     } else {
!        x = zfiles == NULL && zipbeg == 0 ? fopen(zipfile, FOPW) : 
!                                            fopen(zipfile, FOPM);
!       /* Note: FOPW and FOPM expand to several parameters for VMS */
!       if (x == NULL)
!         err(ZE_CREAT, zipfile);
!       fclose(x);
!       a = getfileattr(zipfile);
!       if (zfiles == NULL && zipbeg == 0)
!         destroy(zipfile);
!     }
    }
    else
      a = 0;
  
+   /* Throw away the garbage in front of the zip file for -F */
+   if (fix) zipbeg = 0;
  
    /* Open zip file and temporary output file */
    diag("opening zip file and creating temporary zip file");
***************
*** 739,752 ****
    tempzn = 0;
    if (strcmp(zipfile, "-") == 0)
    {
! #ifdef MSDOS
      /* Set stdout mode to binary for MSDOS systems */
      setmode(fileno(stdout), O_BINARY);
      tempzf = y = fdopen(fileno(stdout), FOPW);
  #else
      tempzf = y = stdout;
  #endif
!     tempzip = "-";
    }
    else if (d) /* d true if just appending (-g) */
    {
--- 855,872 ----
    tempzn = 0;
    if (strcmp(zipfile, "-") == 0)
    {
! #if defined(MSDOS) || defined(__human68k__)
      /* Set stdout mode to binary for MSDOS systems */
      setmode(fileno(stdout), O_BINARY);
      tempzf = y = fdopen(fileno(stdout), FOPW);
  #else
      tempzf = y = stdout;
  #endif
!     /* tempzip must be malloced so a later free won't barf */
!     tempzip = malloc(4);
!     if (tempzip == NULL)
!       err(ZE_MEM, "allocating temp filename");
!     strcpy(tempzip, "-");
    }
    else if (d) /* d true if just appending (-g) */
    {
***************
*** 763,769 ****
      if ((zfiles != NULL || zipbeg) && (x = fopen(zipfile, FOPR_EX)) == NULL)
        err(ZE_NAME, zipfile);
      if ((tempzip = tempname(zipfile)) == NULL)
!       err(ZE_MEM, tempzip);
      if ((tempzf = y = fopen(tempzip, FOPW)) == NULL)
        err(ZE_TEMP, tempzip);
      if (zipbeg && (r = fcopy(x, y, zipbeg)) != ZE_OK)
--- 883,889 ----
      if ((zfiles != NULL || zipbeg) && (x = fopen(zipfile, FOPR_EX)) == NULL)
        err(ZE_NAME, zipfile);
      if ((tempzip = tempname(zipfile)) == NULL)
!       err(ZE_MEM, "allocating temp filename");
      if ((tempzf = y = fopen(tempzip, FOPW)) == NULL)
        err(ZE_TEMP, tempzip);
      if (zipbeg && (r = fcopy(x, y, zipbeg)) != ZE_OK)
